#include <stdio.h>
#include <vector>
#include <queue>

using namespace std;

int main ()
{
#ifdef CONTEST
  freopen("cango.in", "rt", stdin);
  freopen("cango.out", "wt", stdout);
#endif

  int N, M;
  scanf("%d %d", &N, &M);
  vector<int> adj[N+1];

  for (int i=0; i<M; i++) {
    int u, v;
    scanf("%d %d", &u, &v);
    adj[u].push_back(v);
  }

  int src, trg;
  scanf("%d %d", &src, &trg);

  bool visited[N+1];
  for (int i=1; i<=N; i++)
    visited[i] = false;

  queue<int> q;
  q.push(src);
  while (!q.empty()) {
    int u = q.front();
    q.pop();
    visited[u] = true;
    if (u == trg)
      break;
    for (int i=0; i<adj[u].size(); i++) {
      int v = adj[u][i];
      if (!visited[v])
        q.push(v);
    }
  }
  if (visited[trg])
    printf("YES\n");
  else
    printf("NO\n");

  return 0;
}
