#undef DEBUG

#ifdef DEBUG
#define debug(...) fprintf(stderr, __VA_ARGS__)
#else
#define debug(...) do ; while(0)
#define NDEBUG
#endif

#include <assert.h>
#include <stdbool.h>
#include <stdio.h>
#include <limits.h>
#include <vector>
#include <set>
#include <map>
#include <algorithm>

using namespace std;

typedef unsigned long long int num;
typedef set<int> sint;
typedef map<num, sint> mnum;

bool solve (int N, const vector<num> &S, sint &one, sint &two)
{
  mnum seen;

  for (int i=1; i<N; i++) {
    vector<bool> index(N);
    for (int j=0; j<i; j++)
      index[j] = true;
    for (int j=i; j<N; j++)
      index[j] = false;
    do {
      sint t;
      num x = 0;
      for (int j=0; j<N; j++)
        if (index[j]) {
          t.insert(j);
          x += S[j];
        }
      debug("considering %llu: ", x);
      for (sint::iterator i = t.begin(); i != t.end(); i++)
        debug("%s%llu", (i == t.begin() ? "" : " "), S[*i]);
      debug("\n");
      mnum::iterator p = seen.find(x);
      if (p == seen.end())
        seen[x] = t;
      else {
        debug("found!\n");
        one = p->second;
        two = t;
        return true;
      }
    } while (prev_permutation(index.begin(), index.end()));
  }
  return false;
}

int main ()
{
  int C;

  scanf("%d\n", &C);
  for (int c=1; c<=C; c++) {
    // input
    int N;
    scanf("%d\n", &N);
    vector<num> S(N);
    for (int i=0; i<N; i++)
       scanf("%llu", &(S[i]));

    // solve
    sint a, b;
    bool answer = solve(N, S, a, b);

    // answer
    printf("Case #%d:\n", c);
    if (answer) {
      for (sint::iterator i = a.begin(); i != a.end(); i++)
        printf("%s%llu", (i == a.begin() ? "" : " "), S[*i]);
      printf("\n");
      for (sint::iterator i = b.begin(); i != b.end(); i++)
        printf("%s%llu", (i == b.begin() ? "" : " "), S[*i]);
      printf("\n");
    }
    else
      printf("Impossible\n");
  }

  return 0;
}
