#undef DEBUG

#ifdef DEBUG
#define debug(...) fprintf(stderr, __VA_ARGS__)
#else
#define debug(...) do ; while(0)
#define NDEBUG
#endif

#include <assert.h>
#include <stdbool.h>
#include <stdio.h>
#include <vector>
#include <algorithm>

using namespace std;

typedef pair<int, int> pii;
#define mp make_pair
#define fi first
#define se second

#define STA 0
#define STB 1

int main ()
{
  int N;

  scanf("%d\n", &N);
  for (int i=1; i<=N; i++) {
    int T, NA, NB;

    // input and make list of events
    scanf("%d\n", &T);
    scanf("%d %d\n", &NA, &NB);
    vector<pii> ev(2*(NA+NB));
    for (int j=0, k=0; j<NA+NB; j++) {
      int dh, dm, ah, am;
      scanf("%d:%d %d:%d\n", &dh, &dm, &ah, &am);
      int dt = dh*60+dm;
      int ds = j<NA ? STA : STB;
      int at = ah*60+am+T;
      int as = j<NA ? STB : STA;
      ev[k++] = mp(dt, ds);
      ev[k++] = mp(at, -(as+1));
    }

    // sort and simulate events
    sort(ev.begin(), ev.end());

    int n[] = {0, 0};  // number of trains at each station
    int a[] = {0, 0};  // number of trains that must start at each station

    for (int j=0; j<2*(NA+NB); j++) {
      debug("event %d at %02d:%02d\n", ev[j].se, ev[j].fi/60, ev[j].fi%60);
      if (ev[j].se >= 0) {         // departure
        int s = ev[j].se;
        if (n[s] == 0) n[s]++, a[s]++;
        n[s]--;
      }
      else {                       // arrival
        int s = -ev[j].se-1;
        n[s]++;
      }
    }

    // answer
    printf("Case #%d: %d %d\n", i, a[STA], a[STB]);
  }

  return 0;
}
