#include <cstdio>
#define MAX 10005
#define INF 1000000000

using namespace std;

struct Node {
   int node, weight;
   struct Node *next;
} *graph[MAX];

bool visited[MAX];
int dist[MAX];

void add(int u, int v, int w) {
   struct Node *x;
   //x = (struct Node *) malloc(sizeof(struct Node)); // in C
   x = new (struct Node);  // in C++

   x->node = v;
   x->weight = w;
   x->next = graph[u];
   graph[u] = x;
}

void clear() {
   struct Node *t, *q;

   for (int i = 0; i < MAX; i++)
      visited[i] = false;
   for (int i = 0; i < MAX; i++) {
      for (t = graph[i]; t; ) {
         q = t->next;
         delete t;
         t = q;
      }
      graph[i] = NULL;
   }
}

int main() {
   //freopen("dijkstra.in", "r", stdin);
   //freopen("dijkstra.out", "w", stdout);
   int T, u, v, w, A, B, minDist, minNode, n, m;
   struct Node *t;

   scanf("%d", &T);
   for (int k = 1; k <= T; k++) {
      clear();
      scanf("%d%d", &n, &m);

      for (int i = 1; i <= m; i++) {
         scanf("%d%d%d", &u, &v, &w);
         add(u, v, w);
      }

      scanf("%d%d", &A, &B);

      for (int i = 1; i <= n; i++)
         dist[i] = INF;
      dist[A] = 0;

      for (int z = 1; z <= n; z++) {
         minDist = INF; minNode = 0;
         for (int i = 1; i <= n; i++)
            if ( !visited[i] && dist[i] < minDist ) {
               minDist = dist[i];
               minNode = i;
            }

         if (minNode == B) break;

         visited[minNode] = true;
         t = graph[minNode];
         while (t != NULL) {

            if ( dist[t->node] > dist[minNode] + t->weight )
               dist[t->node] = dist[minNode] + t->weight;

            t = t->next;
         }
      }
      
      if (dist[B] == INF)
         printf("NO\n");
      else
         printf("%d\n", dist[B]);
   }
   return 0;
}
