#include <cstdio>
#include <cstring>
#include <vector>

#define MAXN 15
#define pb push_back

using namespace std;

vector<int> e[MAXN], dist[MAXN];
int vis[MAXN], N, M;

void Read() {
	int i, a, b, d;

	scanf ("%d %d", &N, &M);
	for ( i=1; i<=M; ++i ) {
		scanf ("%d %d %d", &a, &b, &d);
		e[a].pb ( b );
		dist[a].pb ( d );
	}
}

bool Negative_Weight_Cycle() {
	int i, j, t, neib, distance;
	int d[MAXN];

	for ( i=1; i<MAXN; ++i ) {
		d[i] = 0x3f3f3f3f; //INF
	}
	d[1] = 0;

	for ( t=1; t<N; ++t ) {
		for ( i=1; i<=N; ++i ) {
			for ( j=0; j<e[i].size(); ++j ) {
				neib = e[i][j];
				distance = dist[i][j];
				if ( d[ neib ] > d[i] + distance ) {
					d[neib] = d[i] + distance;
				}
			}
		}
	}

	for ( i=1; i<=N; ++i ) {
		for ( j=0; j<e[i].size(); ++j ) {
			neib = e[i][j];
			distance = dist[i][j];
			if ( d[ neib ] > d[i] + distance ) {
				return true;
			}
		}
	}

	return false;
}

int main ( void ) {
	int i;

	Read();
	if ( Negative_Weight_Cycle() ) {
		printf ("Oops!!!\n");
	}
	else {
		printf ("No negative weight cycles\n");
	} 
}
