#include <stdio.h>
#include <algorithm>

using namespace std;

struct tree_elem {
  int data;
  tree_elem *left, *right;
};

typedef tree_elem *tree;

int height (tree t)
{
  if (t == NULL)
    return 0;
  else
    return max(height(t->left), height(t->right)) + 1;
}

int weight (tree t)
{
  if (t == NULL)
    return 0;
  else
    return weight(t->left) + weight(t->right) + 1;
}

void print (tree t)
{
  if (t != NULL) {
    printf("%d\n", t->data);
    print(t->left);
    print(t->right);
  }
}

tree insert (tree t, int x)
{
  if (t == NULL) {
    tree n = new tree_elem;
    n->data = x;
    n->left = n->right = NULL;
    return n;
  }
  if (x < t->data)
    t->left = insert(t->left, x);
  else if (x > t->data)
    t->right = insert(t->right, x);
  return t;
}

int main ()
{
  tree t = NULL;
  int i;
  
  for (i=0; i<10; i++) {
    int x;
    scanf("%d", &x);
    t = insert(t, x);
    printf("\nNow we have: height: %d, weight: %d\n",
           height(t), weight(t));
    print(t);
  }

  return 0;
}
