#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <cstring>
#include <vector>
#include <deque>
#include <list>
#include <set>
#include <map>
#include <stack>
#include <queue>
#include <algorithm>

#define MAXN 50005
#define MAXVAL 50005
#define INF 0x3f3f3f3f
#define LINF ((1LL << 62LL ) - 5LL)
#define pb push_back
#define mp make_pair
#define X first
#define Y second

using namespace std;

typedef long long llint;
typedef pair<int,int> pii;
typedef pair<double,double> point;

int dx[8] = {1,0,-1,0,1,-1,-1,1};
int dy[8] = {0,1,0,-1,1,1,-1,-1};

//////////////////////////////////////////////////////////////////////////////////////////////////////////

void Read();

struct Interval {
	int l, r, c;
} inter[MAXN];

int N, L[4*MAXN], T[4*MAXN];
bool Lazy[4*MAXN];

bool comp_r ( Interval a, Interval b ) {
	return a.r < b.r;
}

void Init() {
	memset ( L, 0, sizeof(L) );
	memset ( Lazy, 0, sizeof(Lazy) );
	memset ( T, 0, sizeof(T) );
}

void Update ( int v, int x, int y, int qx, int qy ) {
	if ( x==qx && y==qy ) {
		L[v] = 1;
		Lazy[v] = true;
		T[v] = (y-x+1) * L[v];
		return;
	}
	
	int mid = ( x+y ) / 2;

	if ( Lazy[v] ) {
		Update ( 2*v, x, mid, x, mid );
		Update ( 2*v+1, mid+1, y, mid+1, y );
		Lazy[v] = false;
		L[v] = 0;
	}

	if ( qy <= mid ) {
		Update ( 2*v, x, mid, qx, qy );
	}
	else if ( qx > mid ) {
		Update ( 2*v+1, mid+1, y, qx, qy );
	}
	else {
		Update ( 2*v, x, mid, qx, mid );
		Update ( 2*v+1, mid+1, y, mid+1, qy );
	}

	T[v] = T[2*v] + T[2*v+1];
}

int Sum ( int v, int x, int y, int qx, int qy ) {
	if ( x==qx && y==qy ) {
		return T[v];
	}
	
	int mid = ( x+y ) / 2;

	if ( Lazy[v] ) {
		Update ( 2*v, x, mid, x, mid );
		Update ( 2*v+1, mid+1, y, mid+1, y );
		Lazy[v] = false;
		L[v] = 0;
	}

	if ( qy <= mid ) {
		return Sum ( 2*v, x, mid, qx, qy );
	}
	else if ( qx > mid ) {
		return Sum ( 2*v+1, mid+1, y, qx, qy );
	}
	else {
		return Sum ( 2*v, x, mid, qx, mid ) + Sum ( 2*v+1, mid+1, y, mid+1, qy );
	}
}

void Solve() {
	int i, lo, hi, mid, ans = 0, s;

	for ( i=1; i<=N; ++i ) {

		lo = inter[i].l;
		hi = inter[i].r;
		s = Sum(1,0,MAXVAL,lo,hi);
		if ( s >= inter[i].c ) {
			continue;
		}
		inter[i].c -= s;

		while ( lo < hi ) {
			mid = ( lo+hi+1 ) / 2;
			s = inter[i].r-mid+1 - Sum ( 1, 0, MAXVAL, mid, inter[i].r );
			if ( s >= inter[i].c ) {
				lo = mid;
			}
			else {
				hi = mid-1;
			}
		}

		ans += inter[i].r - lo + 1 - Sum ( 1, 0, MAXVAL, lo, inter[i].r );
		Update ( 1, 0, MAXVAL, lo, inter[i].r );
	}
	printf ("%d\n", ans);
}

int main ( void ) {
	//freopen ("","r",stdin);
	//freopen ("","w",stdout);

	int t, T;

	scanf ("%d", &T);
	for ( t=1; t<=T; ++t ) {
		Read();
		Solve();
		Init();
	}

	return 0;
}

void Read() {
	int i;

	scanf ("%d", &N);
	for ( i=1; i<=N; ++i ) {
		scanf ("%d %d %d", &inter[i].l, &inter[i].r, &inter[i].c);
	}

	sort ( inter+1, inter+N+1, comp_r );
}
