#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#define K 300000

struct node {
    int children[26];
    char isWord;
};

struct node Trie[K];
int trieNodeCount;

int initialize() {
    trieNodeCount = 1;
}

int add(char *word, int length) {
    int i, curNode = 1, nextNode; 

    for (i=0; i<length; i++) {
        nextNode = Trie[curNode].children[ word[i] - 'A' ];

        if ( nextNode == 0 ) { 
            trieNodeCount++;
            Trie[curNode].children[ word[i] - 'A' ] = trieNodeCount;
            curNode = trieNodeCount;
        }
        else {
            curNode = nextNode;
        }
    }

    Trie[curNode].isWord = 1;
}

int main(void) {
    freopen("dict_larger.txt", "r", stdin);
    int i, letterCount = 0, N;
    char s[100];

    scanf("%d\n", &N);

    initialize();

    for (i=0; i<N; i++) {
        scanf("%s", s);
        letterCount += strlen(s);
        add(s, strlen(s));
    }
    
    printf("%6d κόμβοι στο trie\n%d γράμματα συνολικά\n", trieNodeCount, letterCount);

    return 0;
}

